scala.collection.immutable

# StreamViewLike

#### trait StreamViewLike[+A, +Coll, +This <: StreamView[A, Coll] with StreamViewLike[A, Coll, This]] extends SeqView[A, Coll] with SeqViewLike[A, Coll, This]

Self Type
  StreamViewLike[A, Coll, This]
Source
  StreamViewLike.scala

Linear Supertypes
SeqView[A, Coll], GenSeqView[A, Coll], SeqViewLike[A, Coll, This], GenSeqViewLike[A, Coll, This], IterableView[A, Coll], GenIterableView[A, Coll], IterableViewLike[A, Coll, This], GenIterableViewLike[A, Coll, This], TraversableView[A, Coll], GenTraversableView[A, Coll], TraversableViewLike[A, Coll, This], GenTraversableViewLike[A, Coll, This], ViewMkString[A], Seq[A], SeqLike[A, This], GenSeq[A], GenSeqLike[A, This], Iterable[A], IterableLike[A, This], Equals, GenIterable[A], GenIterableLike[A, This], Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, Seq], TraversableLike[A, This], GenTraversableLike[A, This], Parallelizable[A, ParSeq[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, This], HasNewBuilder[A, This], PartialFunction[Int, A], (Int) ⇒ A, AnyRef, Any
Known Subclasses
Appended, DroppedWhile, EmptyView, Filtered, FlatMapped, Forced, Mapped, Patched, Prepended, Reversed, Sliced, StreamView, TakenWhile, Transformed, Zipped, ZippedAll
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. StreamViewLike
2. SeqView
3. GenSeqView
4. SeqViewLike
5. GenSeqViewLike
6. IterableView
7. GenIterableView
8. IterableViewLike
9. GenIterableViewLike
10. TraversableView
11. GenTraversableView
12. TraversableViewLike
13. GenTraversableViewLike
14. ViewMkString
15. Seq
16. SeqLike
17. GenSeq
18. GenSeqLike
19. Iterable
20. IterableLike
21. Equals
22. GenIterable
23. GenIterableLike
24. Traversable
25. GenTraversable
26. GenericTraversableTemplate
27. TraversableLike
28. GenTraversableLike
29. Parallelizable
30. TraversableOnce
31. GenTraversableOnce
32. FilterMonadic
33. HasNewBuilder
34. PartialFunction
35. Function1
36. AnyRef
37. Any

Visibility

1. Public
2. All

### Type Members

1. #### trait Appended[B >: A] extends Appended[B] with Transformed[B]

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

2. #### trait DroppedWhile extends DroppedWhile with Transformed[A]

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

3. #### trait EmptyView extends Transformed[Nothing] with EmptyView

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

4. #### trait Filtered extends Filtered with Transformed[A]

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

5. #### trait FlatMapped[B] extends FlatMapped[B] with Transformed[B]

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

6. #### trait Forced[B] extends Forced[B] with Transformed[B]

   A fall back which forces everything into a vector and then applies an operation on it.

7. #### trait Mapped[B] extends Mapped[B] with Transformed[B]

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

8. #### trait Patched[B >: A] extends Patched[B] with Transformed[B]

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike

9. #### trait Prepended[B >: A] extends Prepended[B] with Transformed[B]

   Definition Classes
     StreamViewLike → SeqViewLike → GenSeqViewLike

10. #### trait Reversed extends Reversed with Transformed[A]

    Definition Classes
      StreamViewLike → SeqViewLike → GenSeqViewLike

11. #### type Self = This

    The type implementing this traversable

    The type implementing this traversable

    Attributes
      protected
    Definition Classes
      TraversableLike

12. #### trait Sliced extends Sliced with Transformed[A]

    Definition Classes
      StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

13. #### trait TakenWhile extends TakenWhile with Transformed[A]

    Definition Classes
      StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike → TraversableViewLike → GenTraversableViewLike

14. #### trait Transformed[+B] extends StreamView[B, Coll] with Transformed[B]

    The implementation base trait of this view.

15. #### class WithFilter extends FilterMonadic[A, Repr]

    A class supporting filtered operations.

16. #### trait Zipped[B] extends Zipped[B] with Transformed[(A, B)]

    Definition Classes
      StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike

17. #### trait ZippedAll[A1 >: A, B] extends ZippedAll[A1, B] with Transformed[(A1, B)]

    Definition Classes
      StreamViewLike → SeqViewLike → GenSeqViewLike → IterableViewLike → GenIterableViewLike

### Abstract Value Members

1. #### abstract def apply(idx: Int): A

   Selects an element by its index in the sequence.

   Selects an element by its index in the sequence.

   Example:

          scala> val x = LinkedList(1, 2, 3, 4, 5)
          x: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4, 5)

          scala> x(3)
          res1: Int = 4

   idx

     The index to select.

   returns

     the element of this sequence at index `idx`, where `0` indicates the first element.

   Definition Classes
     SeqLike → GenSeqLike
   Exceptions thrown
     `IndexOutOfBoundsException`

     if `idx` does not satisfy `0 <= idx < length`.

2. #### abstract def iterator: Iterator[A]

   Creates a new iterator over all elements contained in this iterable object.

   Creates a new iterator over all elements contained in this iterable object.

   returns

     the new iterator

   Definition Classes
     IterableLike → GenIterableLike

3. #### abstract def length: Int

   The length of the sequence.

   The length of the sequence.

   Note: will not terminate for infinite-sized collections.

   Note: `xs.length` and `xs.size` yield the same result.

   returns

     the number of elements in this sequence.

   Definition Classes
     SeqLike → GenSeqLike

4. #### abstract def underlying: Coll

   Attributes
     protected
   Definition Classes
     TraversableViewLike → GenTraversableViewLike

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): Seq[B]

   [use case] Returns a new sequence containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new sequence containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the sequence is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this sequence followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[B >: A, That](xs: GenTraversableOnce[B])(implicit bf: CanBuildFrom[This, B, That]): That

   Returns a new sequence containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new sequence containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the sequence is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this sequence followed by all elements of `that`.

   Definition Classes
     TraversableViewLike → TraversableLike → GenTraversableLike

6. #### def ++:[B >: A, That](that: Traversable[B])(implicit bf: CanBuildFrom[This, B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new sequence which contains all elements of this sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### abstract def ++:[B](that: TraversableOnce[B]): Seq[B]

   [use case] Concatenates this sequence with the elements of a traversable collection.

   [use case]

   Concatenates this sequence with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[This, B, That]): That

   Concatenates this sequence with the elements of a traversable collection.

   Concatenates this sequence with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### abstract def +:(elem: A): Seq[A]

   [use case] A copy of the sequence with an element prepended.

   [use case]

   A copy of the sequence with an element prepended.

   elem

     the prepended element

   returns

     a new collection of type `That` consisting of `elem` followed by all elements of this sequence.

   Definition Classes
     GenSeqLike

10. #### def +:[B >: A, That](elem: B)(implicit bf: CanBuildFrom[This, B, That]): That

    A copy of the sequence with an element prepended.

    A copy of the sequence with an element prepended.

    Note that :-ending operators are right associative (see example). Also, the original sequence is not modified, so you will want to capture the result.

    Example:

             scala> val x = LinkedList(1)
             x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

             scala> val y = 2 +: x
             y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

             scala> println(x)
             LinkedList(1)

    B

      the element type of the returned sequence.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the prepended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this sequence.

    Definition Classes
      SeqViewLike → SeqLike → GenSeqLike

11. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this sequence, going left to right.

    Applies a binary operator to a start value and all elements of this sequence, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    Note: will not terminate for infinite-sized collections.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this sequence, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this sequence.

    Definition Classes
      TraversableOnce → GenTraversableOnce

12. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

13. #### abstract def :+(elem: A): Seq[A]

    [use case] A copy of this sequence with an element appended.

    [use case]

    A copy of this sequence with an element appended.

    elem

      the appended element

    returns

      a new collection of type `That` consisting of all elements of this sequence followed by `elem`.

    Definition Classes
      GenSeqLike

14. #### def :+[B >: A, That](elem: B)(implicit bf: CanBuildFrom[This, B, That]): That

    A copy of this sequence with an element appended.

    A copy of this sequence with an element appended.

    Note: will not terminate for infinite-sized collections.

    B

      the element type of the returned sequence.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the appended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of all elements of this sequence followed by `elem`.

    Definition Classes
      SeqViewLike → SeqLike → GenSeqLike

15. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this sequence and a start value, going right to left.

    Applies a binary operator to all elements of this sequence and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this sequence, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this sequence.

    Definition Classes
      TraversableOnce → GenTraversableOnce

16. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

18. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Definition Classes
      ViewMkString

19. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this sequence to a string builder.

    Appends all elements of this sequence to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this sequence without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

20. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this sequence to a string builder using a separator string.

    Appends all elements of this sequence to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this sequence, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

21. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

22. #### def andThen[C](k: (A) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

23. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

24. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this sequence should be compared

    returns

      `true`, if this sequence can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

25. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

26. #### abstract def collect[B](pf: PartialFunction[A, B]): Seq[B]

    [use case] Builds a new collection by applying a partial function to all elements of this sequence on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this sequence on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the sequence.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

27. #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[This, B, That]): That

    Builds a new collection by applying a partial function to all elements of this sequence on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this sequence on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the sequence.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

28. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the sequence for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the sequence for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

29. #### def combinations(n: Int): Iterator[This]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this sequence.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

30. #### def companion: GenericCompanion[Seq]

    The factory companion object that builds instances of class Seq.

    The factory companion object that builds instances of class Seq. (or its `Iterable` superclass where class Seq is not a `Seq`.)

    Definition Classes
      Seq → GenSeq → Iterable → GenIterable → Traversable → GenTraversable → GenericTraversableTemplate

31. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ A

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

32. #### def contains(elem: Any): Boolean

    Tests whether this sequence contains a given value as an element.

    Tests whether this sequence contains a given value as an element.

    Note: may not terminate for infinite-sized collections.

    elem

      the element to test.

    returns

      `true` if this sequence has an element that is is equal (wrt `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

33. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this sequence contains a given sequence as a slice.

    Tests whether this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      `true` if this sequence contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

34. #### abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this sequence to an array.

    [use case]

    Copies elements of this sequence to an array. Fills the given array `xs` with at most `len` elements of this sequence, starting at position `start`. Copying will stop once either the end of the current sequence is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

35. #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this sequence to an array.

    Copies elements of this sequence to an array. Fills the given array `xs` with at most `len` elements of this sequence, starting at position `start`. Copying will stop once either the end of the current sequence is reached, or the end of the array is reached, or `len` elements have been copied.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

36. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this sequence to an array.

    [use case]

    Copies values of this sequence to an array. Fills the given array `xs` with values of this sequence. Copying will stop once either the end of the current sequence is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

37. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this sequence to an array.

    Copies values of this sequence to an array. Fills the given array `xs` with values of this sequence. Copying will stop once either the end of the current sequence is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

38. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this sequence to an array.

    [use case]

    Copies values of this sequence to an array. Fills the given array `xs` with values of this sequence, beginning at index `start`. Copying will stop once either the end of the current sequence is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

39. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this sequence to an array.

    Copies values of this sequence to an array. Fills the given array `xs` with values of this sequence, beginning at index `start`. Copying will stop once either the end of the current sequence is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

40. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this sequence to a buffer.

    Copies all elements of this sequence to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

41. #### def corresponds[B](that: GenSeq[B])(p: (A, B) ⇒ Boolean): Boolean

    Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this sequence and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

42. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the sequence which satisfy a predicate.

    Counts the number of elements in the sequence which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

43. #### abstract def diff(that: Seq[A]): Seq[A]

    [use case] Computes the multiset difference between this sequence and another sequence.

    [use case]

    Computes the multiset difference between this sequence and another sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this sequence except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike

44. #### def diff[B >: A](that: GenSeq[B]): This

    Computes the multiset difference between this sequence and another sequence.

    Computes the multiset difference between this sequence and another sequence.

    Note: will not terminate for infinite-sized collections.

    B

      the element type of the returned sequence.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this sequence except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqViewLike → SeqLike → GenSeqLike

45. #### def distinct: This

    Builds a new sequence from this sequence without any duplicate elements.

    Builds a new sequence from this sequence without any duplicate elements.

    Note: will not terminate for infinite-sized collections.

    returns

      A new sequence which contains the first occurrence of every element of this sequence.

    Definition Classes
      SeqLike → GenSeqLike

46. #### def drop(n: Int): This

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this sequence.

    returns

      a sequence consisting of all elements of this sequence except the first `n` ones, or else the empty sequence, if this sequence has less than `n` elements.

    Definition Classes
      IterableViewLike → TraversableViewLike → IterableLike → TraversableLike → GenTraversableLike

47. #### def dropRight(n: Int): This

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a sequence consisting of all elements of this sequence except the last `n` ones, or else the empty sequence, if this sequence has less than `n` elements.

    Definition Classes
      IterableLike

48. #### def dropWhile(p: (A) ⇒ Boolean): This

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this sequence whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

49. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this sequence ends with the given sequence.

    Tests whether this sequence ends with the given sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      `true` if this sequence has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqLike → GenSeqLike

50. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

51. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → AnyRef → Any

52. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this sequence.

    Tests whether a predicate holds for some of the elements of this sequence.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this sequence, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

53. #### def filter(p: (A) ⇒ Boolean): This

    Selects all elements of this sequence which satisfy a predicate.

    Selects all elements of this sequence which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new sequence consisting of all elements of this sequence that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

54. #### def filterNot(p: (A) ⇒ Boolean): This

    Selects all elements of this sequence which do not satisfy a predicate.

    Selects all elements of this sequence which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new sequence consisting of all elements of this sequence that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

55. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

56. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the sequence satisfying a predicate, if any.

    Finds the first element of the sequence satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the sequence that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

57. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): Seq[B]

    [use case] Builds a new collection by applying a function to all elements of this sequence and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this sequence and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this sequence and concatenating the results.

    Definition Classes
      GenTraversableLike

58. #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[This, B, That]): That

    Builds a new collection by applying a function to all elements of this sequence and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this sequence and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of sequence. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this sequence and concatenating the results.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike → FilterMonadic

59. #### abstract def flatten[B]: Seq[B]

    [use case] Converts this sequence of traversable collections into a sequence formed by the elements of these traversable collections.

    [use case]

    Converts this sequence of traversable collections into a sequence formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new sequence resulting from concatenating all element sequences.

    Definition Classes
      GenericTraversableTemplate

60. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this sequence using the specified associative binary operator.

    Folds the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

61. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this sequence, going left to right.

    Applies a binary operator to a start value and all elements of this sequence, going left to right.

    Note: will not terminate for infinite-sized collections.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this sequence, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this sequence.

    Definition Classes
      TraversableOnce → GenTraversableOnce

62. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this sequence and a start value, going right to left.

    Applies a binary operator to all elements of this sequence and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this sequence, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this sequence.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

63. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this sequence.

    Tests whether a predicate holds for all elements of this sequence.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this sequence, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

64. #### def force[B >: A, That](implicit bf: CanBuildFrom[Coll, B, That]): That

    Definition Classes
      StreamViewLike → TraversableViewLike → GenTraversableViewLike

65. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this sequence.

    [use case]

    Applies a function `f` to all elements of this sequence.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

66. #### def foreach[U](f: (A) ⇒ U): Unit

    Applies a function `f` to all elements of this sequence.

    Applies a function `f` to all elements of this sequence.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

67. #### def genericBuilder[B]: Builder[B, Seq[B]]

    The generic builder that builds instances of Seq at arbitrary element types.

    The generic builder that builds instances of Seq at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

68. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

69. #### def groupBy[K](f: (A) ⇒ K): Map[K, This]

    Partitions this sequence into a map of sequences according to some discriminator function.

    Partitions this sequence into a map of sequences according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new sequence.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to sequences such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a sequence of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableViewLike → TraversableLike → GenTraversableLike

70. #### def grouped(size: Int): Iterator[This]

    Partitions elements in fixed size sequences.

    Partitions elements in fixed size sequences.

    size

      the number of elements per group

    returns

      An iterator producing sequences of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableViewLike → IterableLike
    See also

      Iterator#grouped

71. #### def hasDefiniteSize: Boolean

    Tests whether this sequence is known to have a finite size.

    Tests whether this sequence is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

72. #### def hashCode(): Int

    Hashcodes for Seq produce a value from the hashcodes of all the elements of the sequence.

    Hashcodes for Seq produce a value from the hashcodes of all the elements of the sequence.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → AnyRef → Any

73. #### def head: A

    Selects the first element of this sequence.

    Selects the first element of this sequence.

    returns

      the first element of this sequence.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the sequence is empty.

74. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this sequence if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

75. #### abstract def indexOf(elem: A, from: Int): Int

    [use case] Finds index of first occurrence of some value in this sequence after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this sequence after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

76. #### def indexOf[B >: A](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this sequence after or at some start index.

    Finds index of first occurrence of some value in this sequence after or at some start index.

    Note: may not terminate for infinite-sized collections.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

77. #### abstract def indexOf(elem: A): Int

    [use case] Finds index of first occurrence of some value in this sequence.

    [use case]

    Finds index of first occurrence of some value in this sequence.

    elem

      the element value to search for.

    returns

      the index of the first element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

78. #### def indexOf[B >: A](elem: B): Int

    Finds index of first occurrence of some value in this sequence.

    Finds index of first occurrence of some value in this sequence.

    Note: may not terminate for infinite-sized collections.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the first element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

79. #### def indexOfSlice[B >: A](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this sequence contains a given sequence as a slice.

    Finds first index after or at a start index where this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

80. #### def indexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds first index where this sequence contains a given sequence as a slice.

    Finds first index where this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      the first index such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

81. #### def indexWhere(p: (A) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

82. #### def indexWhere(p: (A) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

83. #### def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this sequence.

    Definition Classes
      SeqLike

84. #### def init: This

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a sequence consisting of all elements of this sequence except the last one.

    Definition Classes
      TraversableViewLike → TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the sequence is empty.

85. #### def inits: Iterator[This]

    Iterates over the inits of this sequence.

    Iterates over the inits of this sequence. The first value will be this sequence and the final one will be an empty sequence, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this sequence

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

86. #### abstract def intersect(that: Seq[A]): Seq[A]

    [use case] Computes the multiset intersection between this sequence and another sequence.

    [use case]

    Computes the multiset intersection between this sequence and another sequence.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this sequence which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike

87. #### def intersect[B >: A](that: GenSeq[B]): This

    Computes the multiset intersection between this sequence and another sequence.

    Computes the multiset intersection between this sequence and another sequence.

    Note: may not terminate for infinite-sized collections.

    B

      the element type of the returned sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this sequence which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqViewLike → SeqLike → GenSeqLike

88. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this sequence contains given index.

    Tests whether this sequence contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this sequence contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

89. #### def isEmpty: Boolean

    Tests whether the sequence is empty.

    Tests whether the sequence is empty.

    returns

      `true` if the sequence contains no elements, `false` otherwise.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

90. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

91. #### final def isTraversableAgain: Boolean

    Tests whether this sequence can be repeatedly traversed.

    Tests whether this sequence can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

92. #### def last: A

    Selects the last element.

    Selects the last element.

    returns

      The last element of this sequence.

    Definition Classes
      TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the sequence is empty.

93. #### abstract def lastIndexOf(elem: A, end: Int): Int

    [use case] Finds index of last occurrence of some value in this sequence before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this sequence before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

94. #### def lastIndexOf[B >: A](elem: B, end: Int): Int

    Finds index of last occurrence of some value in this sequence before or at a given end index.

    Finds index of last occurrence of some value in this sequence before or at a given end index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

95. #### abstract def lastIndexOf(elem: A): Int

    [use case] Finds index of last occurrence of some value in this sequence.

    [use case]

    Finds index of last occurrence of some value in this sequence.

    elem

      the element value to search for.

    returns

      the index of the last element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

96. #### def lastIndexOf[B >: A](elem: B): Int

    Finds index of last occurrence of some value in this sequence.

    Finds index of last occurrence of some value in this sequence.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the last element of this sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

97. #### def lastIndexOfSlice[B >: A](that: GenSeq[B], end: Int): Int

    Finds last index before or at a given end index where this sequence contains a given sequence as a slice.

    Finds last index before or at a given end index where this sequence contains a given sequence as a slice.

    that

      the sequence to test

    end

      the end index

    returns

      the last index `<= end` such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

98. #### def lastIndexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds last index where this sequence contains a given sequence as a slice.

    Finds last index where this sequence contains a given sequence as a slice.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      the last index such that the elements of this sequence starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

99. #### def lastIndexWhere(p: (A) ⇒ Boolean, end: Int): Int

    Finds index of last element satisfying some predicate before or at given end index.

    Finds index of last element satisfying some predicate before or at given end index.

    p

      the predicate used to test elements.

    returns

      the index `<= end` of the last element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

100. #### def lastIndexWhere(p: (A) ⇒ Boolean): Int

     Finds index of last element satisfying some predicate.

     Finds index of last element satisfying some predicate.

     Note: will not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     returns

       the index of the last element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

101. #### def lastOption: Option[A]

     Optionally selects the last element.

     Optionally selects the last element.

     returns

       the last element of this sequence$ if it is nonempty, `None` if it is empty.

     Definition Classes
       TraversableLike

102. #### def lengthCompare(len: Int): Int

     Compares the length of this sequence to a test value.

     Compares the length of this sequence to a test value.

     len

       the test value that gets compared with the length.

     returns

       A value `x` where

                  x <  0       if this.length <  len
                  x == 0       if this.length == len
                  x >  0       if this.length >  len

       The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

     Definition Classes
       SeqLike

103. #### def lift: (Int) ⇒ Option[A]

     Turns this partial function into an plain function returning an `Option` result.

     Turns this partial function into an plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

104. #### abstract def map[B](f: (A) ⇒ B): Seq[B]

     [use case] Builds a new collection by applying a function to all elements of this sequence.

     [use case]

     Builds a new collection by applying a function to all elements of this sequence.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this sequence and collecting the results.

     Definition Classes
       GenTraversableLike

105. #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[This, B, That]): That

     Builds a new collection by applying a function to all elements of this sequence.

     Builds a new collection by applying a function to all elements of this sequence.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this sequence and collecting the results.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike → FilterMonadic

106. #### abstract def max: A

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this sequence with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

107. #### def max[B >: A](implicit cmp: Ordering[B]): A

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the largest element of this sequence with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

108. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

109. #### abstract def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this sequence with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

110. #### def min[B >: A](implicit cmp: Ordering[B]): A

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the smallest element of this sequence with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

111. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

112. #### def mkString(start: String, sep: String, end: String): String

     Definition Classes
       ViewMkString

113. #### def mkString(sep: String): String

     Definition Classes
       ViewMkString

114. #### def mkString: String

     Definition Classes
       ViewMkString

115. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

116. #### def newAppended[B >: A](that: GenTraversable[B]): Transformed[B]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

117. #### def newBuilder: Builder[A, This]

     The builder that builds instances of type Seq[A]

     The builder that builds instances of type Seq[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableViewLike → GenericTraversableTemplate → TraversableLike → HasNewBuilder

118. #### def newDropped(n: Int): Transformed[A]

     Attributes
       protected
     Definition Classes
       SeqViewLike → IterableViewLike → TraversableViewLike

119. #### def newDroppedWhile(p: (A) ⇒ Boolean): Transformed[A]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

120. #### def newFiltered(p: (A) ⇒ Boolean): Transformed[A]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

121. #### def newFlatMapped[B](f: (A) ⇒ GenTraversableOnce[B]): Transformed[B]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

122. #### def newForced[B](xs: ⇒ GenSeq[B]): Transformed[B]

     boilerplate

     boilerplate

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

123. #### def newMapped[B](f: (A) ⇒ B): Transformed[B]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

124. #### def newPatched[B >: A](_from: Int, _patch: GenSeq[B], _replaced: Int): Transformed[B]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike

125. #### def newPrepended[B >: A](elem: B): Transformed[B]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike

126. #### def newReversed: Transformed[A]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike

127. #### def newSliced(_endpoints: SliceInterval): Transformed[A]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

128. #### def newTaken(n: Int): Transformed[A]

     Attributes
       protected
     Definition Classes
       SeqViewLike → IterableViewLike → TraversableViewLike

129. #### def newTakenWhile(p: (A) ⇒ Boolean): Transformed[A]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike

130. #### def newZipped[B](that: GenIterable[B]): Transformed[(A, B)]

     Boilerplate method, to override in each subclass This method could be eliminated if Scala had virtual classes

     Boilerplate method, to override in each subclass This method could be eliminated if Scala had virtual classes

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike

131. #### def newZippedAll[A1 >: A, B](that: GenIterable[B], _thisElem: A1, _thatElem: B): Transformed[(A1, B)]

     Attributes
       protected
     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike

132. #### def nonEmpty: Boolean

     Tests whether the sequence is not empty.

     Tests whether the sequence is not empty.

     returns

       `true` if the sequence contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

133. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

134. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

135. #### def orElse[A1 <: Int, B1 >: A](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

136. #### abstract def padTo(len: Int, elem: A): Seq[A]

     [use case] A copy of this sequence with an element value appended until a given target length is reached.

     [use case]

     A copy of this sequence with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new collection of type `That` consisting of all elements of this sequence followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       GenSeqLike

137. #### def padTo[B >: A, That](len: Int, elem: B)(implicit bf: CanBuildFrom[This, B, That]): That

     A copy of this sequence with an element value appended until a given target length is reached.

     A copy of this sequence with an element value appended until a given target length is reached.

     B

       the element type of the returned sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     len

       the target length

     elem

       the padding value

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` consisting of all elements of this sequence followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       SeqViewLike → SeqLike → GenSeqLike

138. #### def par: ParSeq[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

139. #### def parCombiner: Combiner[A, ParSeq[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → TraversableLike → Parallelizable

140. #### def partition(p: (A) ⇒ Boolean): (This, This)

     Partitions this sequence in two sequences according to a predicate.

     Partitions this sequence in two sequences according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of sequences: the first sequence consists of all elements that satisfy the predicate `p` and the second sequence consists of all elements that don't. The relative order of the elements in the resulting sequences is the same as in the original sequence.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

141. #### abstract def patch(from: Int, that: GenSeq[A], replaced: Int): Seq[A]

     [use case] Produces a new sequence where a slice of elements in this sequence is replaced by another sequence.

     [use case]

     Produces a new sequence where a slice of elements in this sequence is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original sequence

     returns

       a new sequence consisting of all elements of this sequence except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       GenSeqLike

142. #### def patch[B >: A, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[This, B, That]): That

     Produces a new sequence where a slice of elements in this sequence is replaced by another sequence.

     Produces a new sequence where a slice of elements in this sequence is replaced by another sequence.

     B

       the element type of the returned sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     from

       the index of the first replaced element

     patch

       the replacement sequence

     replaced

       the number of elements to drop in the original sequence

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new sequence consisting of all elements of this sequence except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqViewLike → SeqLike → GenSeqLike

143. #### def permutations: Iterator[This]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this sequence.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

144. #### def prefixLength(p: (A) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this sequence such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

145. #### abstract def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this sequence with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

146. #### def product[B >: A](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this sequence with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

147. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this sequence using the specified associative binary operator.

     Reduces the elements of this sequence using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the sequence is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this sequence is empty.

148. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

     Definition Classes
       TraversableOnce

149. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this sequence, going left to right.

     Optionally applies a binary operator to all elements of this sequence, going left to right.

     Note: will not terminate for infinite-sized collections.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this sequence is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

150. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this sequence, if any, using the specified associative binary operator.

     Reduces the elements of this sequence, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

151. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this sequence, going right to left.

     Applies a binary operator to all elements of this sequence, going right to left.

     Note: will not terminate for infinite-sized collections.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this sequence, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this sequence.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this sequence is empty.

152. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this sequence, going right to left.

     Optionally applies a binary operator to all elements of this sequence, going right to left.

     Note: will not terminate for infinite-sized collections.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this sequence is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

153. #### def repr: This

     The collection of type sequence underlying this `TraversableLike` object.

     The collection of type sequence underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

154. #### def reverse: This

     Returns new sequence wih elements in reversed order.

     Returns new sequence wih elements in reversed order.

     Note: will not terminate for infinite-sized collections.

     returns

       A new sequence with all elements of this sequence in reversed order.

     Definition Classes
       SeqViewLike → SeqLike → GenSeqLike

155. #### def reverseIterator: Iterator[A]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: will not terminate for infinite-sized collections.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this sequence in reversed order

     Definition Classes
       SeqLike

156. #### abstract def reverseMap[B](f: (A) ⇒ B): Seq[B]

     [use case] Builds a new collection by applying a function to all elements of this sequence and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this sequence and collecting the results in reversed order.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this sequence and collecting the results in reversed order.

       Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     Definition Classes
       GenSeqLike

157. #### def reverseMap[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[This, B, That]): That

     Builds a new collection by applying a function to all elements of this sequence and collecting the results in reversed order.

     Builds a new collection by applying a function to all elements of this sequence and collecting the results in reversed order.

     Note: will not terminate for infinite-sized collections.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this sequence and collecting the results in reversed order.

     Definition Classes
       SeqViewLike → SeqLike → GenSeqLike

158. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

159. #### abstract def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this sequence.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this sequence.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

160. #### def sameElements[B >: A](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this sequence.

     Checks if the other iterable collection contains the same elements in the same order as this sequence.

     Note: will not terminate for infinite-sized collections.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike

161. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[This, B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new sequence containing the prefix scan of the elements in this sequence

     Definition Classes
       TraversableLike → GenTraversableLike

162. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[This, B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

163. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[This, B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: will not terminate for infinite-sized collections.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

164. #### def segmentLength(p: (A) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this sequence starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqLike → GenSeqLike

165. #### def seq: Seq[A]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Seq → GenSeq → Iterable → GenIterable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

166. #### def size: Int

     The size of this sequence, equivalent to `length`.

     The size of this sequence, equivalent to `length`.

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this sequence.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

167. #### def slice(from: Int, until: Int): This

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     from

       the lowest index to include from this sequence.

     until

       the highest index to EXCLUDE from this sequence.

     returns

       a sequence containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this sequence.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

168. #### def sliding[B >: A](size: Int, step: Int): Iterator[This]

     Definition Classes
       IterableViewLike → IterableLike

169. #### def sliding[B >: A](size: Int): Iterator[This]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing sequences of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

170. #### def sortBy[B](f: (A) ⇒ B)(implicit ord: Ordering[B]): This

     Sorts this Seq according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this Seq according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a sequence consisting of the elements of this sequence sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.        val words = "The quick brown fox jumped over the lazy dog".split(' ')
               // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
               words.sortBy(x => (x.length, x.head))
               res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

       Note: will not terminate for infinite-sized collections.

171. #### def sortWith(lt: (A, A) ⇒ Boolean): This

     Sorts this sequence according to a comparison function.

     Sorts this sequence according to a comparison function.

     Note: will not terminate for infinite-sized collections.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a sequence consisting of the elements of this sequence sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.        List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
               List("Bob", "John", "Steve", "Tom")

172. #### def sorted[B >: A](implicit ord: Ordering[B]): This

     Sorts this sequence according to an Ordering.

     Sorts this sequence according to an Ordering.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a sequence consisting of the elements of this sequence sorted according to the ordering `ord`.

     Definition Classes
       SeqViewLike → SeqLike
     See also

       scala.math.Ordering

173. #### def span(p: (A) ⇒ Boolean): (This, This)

     Splits this sequence into a prefix/suffix pair according to a predicate.

     Splits this sequence into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this sequence whose elements all satisfy `p`, and the rest of this sequence.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

174. #### def splitAt(n: Int): (This, This)

     Splits this sequence into two at a given position.

     Splits this sequence into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of sequences consisting of the first `n` elements of this sequence, and the other elements.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

175. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this sequence contains the given sequence at a given index.

     Tests whether this sequence contains the given sequence at a given index.

     If the both the receiver object, `this` and the argument, `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this sequence at index `offset`, otherwise `false`.

     Definition Classes
       SeqLike → GenSeqLike

176. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this sequence starts with the given sequence.

     Tests whether this sequence starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

177. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this sequence. By default the string prefix is the simple name of the collection class sequence.

     Definition Classes
       StreamViewLike → SeqViewLike → IterableViewLike → TraversableViewLike → TraversableLike → GenTraversableLike

178. #### abstract def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this sequence with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

179. #### def sum[B >: A](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this sequence with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

180. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

181. #### def tail: This

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a sequence consisting of all elements of this sequence except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the sequence is empty.

182. #### def tails: Iterator[This]

     Iterates over the tails of this sequence.

     Iterates over the tails of this sequence. The first value will be this sequence and the final one will be an empty sequence, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this sequence

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

183. #### def take(n: Int): This

     Selects first n elements.

     Selects first n elements.

     n

       Tt number of elements to take from this sequence.

     returns

       a sequence consisting only of the first `n` elements of this sequence, or else the whole sequence, if it has less than `n` elements.

     Definition Classes
       IterableViewLike → TraversableViewLike → IterableLike → TraversableLike → GenTraversableLike

184. #### def takeRight(n: Int): This

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a sequence consisting only of the last `n` elements of this sequence, or else the whole sequence, if it has less than `n` elements.

     Definition Classes
       IterableLike

185. #### def takeWhile(p: (A) ⇒ Boolean): This

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this sequence whose elements all satisfy the predicate `p`.

     Definition Classes
       TraversableViewLike → TraversableLike → GenTraversableLike

186. #### def thisCollection: Seq[A]

     The underlying collection seen as an instance of `Seq`.

     The underlying collection seen as an instance of `Seq`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

187. #### def thisSeq: Seq[A]

     Attributes
       protected[this]
     Definition Classes
       ViewMkString

188. #### abstract def toArray: Array[A]

     [use case] Converts this sequence to an array.

     [use case]

     Converts this sequence to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this sequence.

     Definition Classes
       GenTraversableOnce

189. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

     Converts this sequence to an array.

     Converts this sequence to an array.

     Note: will not terminate for infinite-sized collections.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

190. #### def toBuffer[B >: A]: Buffer[B]

     Converts this sequence to a mutable buffer.

     Converts this sequence to a mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

191. #### def toCollection(repr: This): Seq[A]

     A conversion from collections of type `Repr` to `Seq` objects.

     A conversion from collections of type `Repr` to `Seq` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

192. #### def toIndexedSeq[B >: A]: IndexedSeq[B]

     Converts this sequence to an indexed sequence.

     Converts this sequence to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

193. #### def toIterable: Iterable[A]

     Converts this sequence to an iterable collection.

     Converts this sequence to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this sequence.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

194. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this sequence.

     Returns an Iterator over the elements in this sequence. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this sequence.

     Definition Classes
       TraversableLike → GenTraversableOnce

195. #### def toList: List[A]

     Converts this sequence to a list.

     Converts this sequence to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

196. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this sequence to a map.

     [use case]

     Converts this sequence to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this sequence.

     Definition Classes
       GenTraversableOnce

197. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

     Converts this sequence to a map.

     Converts this sequence to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

198. #### def toSeq: Seq[A]

     Converts this sequence to a sequence.

     Converts this sequence to a sequence.

     Note: will not terminate for infinite-sized collections.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this sequence.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

199. #### def toSet[B >: A]: Set[B]

     Converts this sequence to a set.

     Converts this sequence to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

200. #### def toStream: Stream[A]

     Converts this sequence to a stream.

     Converts this sequence to a stream.

     Note: will not terminate for infinite-sized collections.

     returns

       a stream containing all elements of this sequence.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

201. #### def toString(): String

     Converts this sequence to a string.

     Converts this sequence to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this sequence, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       TraversableViewLike → TraversableLike → AnyRef → Any

202. #### def toTraversable: Traversable[A]

     Converts this sequence to an unspecified Traversable.

     Converts this sequence to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this sequence.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

203. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Seq[Seq[B]]

     Transposes this sequence of traversable collections into a sequence of sequences.

     Transposes this sequence of traversable collections into a sequence of sequences.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this sequence is a `Traversable`.

     returns

       a two-dimensional sequence of sequences which has as nth row the nth column of this sequence.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this sequence are not of the same size.

204. #### abstract def union(that: Seq[A]): Seq[A]

     [use case] Produces a new sequence which contains all elements of this sequence and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this sequence and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Note: will not terminate for infinite-sized collections.

     that

       the sequence to add.

     returns

       a new collection of type `That` which contains all elements of this sequence followed by all elements of `that`.

     Definition Classes
       SeqLike

205. #### def union[B >: A, That](that: GenSeq[B])(implicit bf: CanBuildFrom[This, B, That]): That

     Produces a new sequence which contains all elements of this sequence and also all elements of a given sequence.

     Produces a new sequence which contains all elements of this sequence and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Note: will not terminate for infinite-sized collections.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     Note: will not terminate for infinite-sized collections.

     B

       the element type of the returned sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     that

       the sequence to add.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` which contains all elements of this sequence followed by all elements of `that`.

     Definition Classes
       SeqViewLike → SeqLike → GenSeqLike

206. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (Seq[A1], Seq[A2])

     Converts this sequence of pairs into two collections of the first and second half of each pair.

     Converts this sequence of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this sequence is a pair.

     returns

       a pair sequences, containing the first, respectively second half of each element pair of this sequence.

     Definition Classes
       GenericTraversableTemplate

207. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (Seq[A1], Seq[A2], Seq[A3])

     Converts this sequence of triples into three collections of the first, second, and third element of each triple.

     Converts this sequence of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this sequence is a triple.

     returns

       a triple sequences, containing the first, second, respectively third member of each element triple of this sequence.

     Definition Classes
       GenericTraversableTemplate

208. #### abstract def updated(index: Int, elem: A): Seq[A]

     [use case] A copy of this sequence with one single replaced element.

     [use case]

     A copy of this sequence with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new sequence`which is a copy of this sequence with the element at position` index`replaced by` elem`.`

     Definition Classes
       GenSeqLike

209. #### def updated[B >: A, That](index: Int, elem: B)(implicit bf: CanBuildFrom[This, B, That]): That

     A copy of this sequence with one single replaced element.

     A copy of this sequence with one single replaced element.

     B

       the element type of the returned sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     index

       the position of the replacement

     elem

       the replacing element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new sequence`which is a copy of this sequence with the element at position` index`replaced by` elem`.`

     Definition Classes
       SeqViewLike → SeqLike → GenSeqLike

210. #### def view(from: Int, until: Int): SeqView[A, This]

     Creates a non-strict view of a slice of this sequence.

     Creates a non-strict view of a slice of this sequence.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current sequence, whereas `slice` produces a new sequence.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this sequence, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

211. #### def view: SeqView[A, This]

     Creates a non-strict view of this sequence.

     Creates a non-strict view of this sequence.

     returns

       a non-strict view of this sequence.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

212. #### def viewIdString: String

     Attributes
       protected[this]
     Definition Classes
       TraversableViewLike → GenTraversableViewLike

213. #### def viewIdentifier: String

     Attributes
       protected[this]
     Definition Classes
       TraversableViewLike → GenTraversableViewLike

214. #### def viewToString: String

     Definition Classes
       GenTraversableViewLike

215. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

216. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

217. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

218. #### def withFilter(p: (A) ⇒ Boolean): This

     Creates a non-strict filter of this sequence.

     Creates a non-strict filter of this sequence.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this sequence which satisfy the predicate `p`.

     Definition Classes
       TraversableViewLike → TraversableLike → FilterMonadic

219. #### abstract def zip[B](that: GenIterable[B]): Seq[(A, B)]

     [use case] Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this sequence and `that`. The length of the returned collection is the minimum of the lengths of this sequence and `that`.

     Definition Classes
       GenIterableLike

220. #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[This, (A1, B), That]): That

     Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs.

     Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this sequence and `that`. The length of the returned collection is the minimum of the lengths of this sequence and `that`.

     Definition Classes
       IterableViewLike → IterableLike → GenIterableLike

221. #### abstract def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): Seq[(A, B)]

     [use case] Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this sequence is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this sequence.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this sequence and `that`. The length of the returned collection is the maximum of the lengths of this sequence and `that`. If this sequence is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this sequence, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

222. #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[This, (A1, B), That]): That

     Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs.

     Returns a sequence formed from this sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this sequence is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this sequence.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this sequence and `that`. The length of the returned collection is the maximum of the lengths of this sequence and `that`. If this sequence is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this sequence, `thatElem` values are used to pad the result.

     Definition Classes
       IterableViewLike → IterableLike → GenIterableLike

223. #### abstract def zipWithIndex: Seq[(A, Int)]

     [use case] Zips this sequence with its indices.

     [use case]

     Zips this sequence with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this sequence paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

224. #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[This, (A1, Int), That]): That

     Zips this sequence with its indices.

     Zips this sequence with its indices.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this sequence paired with their index. Indices start at `0`.

     Definition Classes
       IterableViewLike → IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def elements: Iterator[A]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

2. #### def equalsWith[B](that: Seq[B])(f: (A, B) ⇒ Boolean): Boolean

   Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

   Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

   B

     the type of the elements of `that`

   that

     the other sequence

   returns

     `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this sequence and `y` of `that`, otherwise `false`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `corresponds` instead

3. #### def findIndexOf(p: (A) ⇒ Boolean): Int

   Returns index of the first element satisfying a predicate, or `-1`.

   Returns index of the first element satisfying a predicate, or `-1`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) Use indexWhere(p) instead.

4. #### def findLastIndexOf(p: (A) ⇒ Boolean): Int

   Returns index of the last element satisfying a predicate, or -1.

   Returns index of the last element satisfying a predicate, or -1.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `lastIndexWhere` instead

5. #### def first: A

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

6. #### def firstOption: Option[A]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

7. #### def projection: SeqView[A, This]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     SeqLike → IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

8. #### def reversedElements: Iterator[A]

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `reverseIterator' instead`

### Inherited from SeqView[A, Coll]

### Inherited from GenSeqView[A, Coll]

### Inherited from SeqViewLike[A, Coll, This]

### Inherited from GenSeqViewLike[A, Coll, This]

### Inherited from IterableView[A, Coll]

### Inherited from GenIterableView[A, Coll]

### Inherited from IterableViewLike[A, Coll, This]

### Inherited from GenIterableViewLike[A, Coll, This]

### Inherited from TraversableView[A, Coll]

### Inherited from GenTraversableView[A, Coll]

### Inherited from TraversableViewLike[A, Coll, This]

### Inherited from GenTraversableViewLike[A, Coll, This]

### Inherited from ViewMkString[A]

### Inherited from Seq[A]

### Inherited from SeqLike[A, This]

### Inherited from GenSeq[A]

### Inherited from GenSeqLike[A, This]

### Inherited from Iterable[A]

### Inherited from IterableLike[A, This]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, This]

### Inherited from Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, Seq]

### Inherited from TraversableLike[A, This]

### Inherited from GenTraversableLike[A, This]

### Inherited from Parallelizable[A, ParSeq[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, This]

### Inherited from HasNewBuilder[A, This]

### Inherited from PartialFunction[Int, A]

### Inherited from (Int) ⇒ A

### Inherited from AnyRef

### Inherited from Any